'Looping waveshaper

'Init
$regfile = "m88def.dat"
$crystal = 8000000
$baud = 19200

Config Timer0 = Pwm , Prescale = 1 , Compare A Pwm = Clear Up , Compare B Pwm = Clear Up       'config timer0
Set Tccr0a.wgm01                                            'double pwm duty frequency so that it's out of audible range


Config Adc = Single , Prescaler = Auto , Reference = Internal
Start Adc
Config Pind.7 = Input                                       'config record button
Config Pind.5 = Input                                       'config punch-in toggle

'Variables
Dim Wavesample As Word
Dim Loopspeed As Word
Dim Waveloop(940) As Byte
Dim Sampleposition As Word
Dim Looplength As Word
Dim Limitreached As Boolean

'give default "quiet" sample on turn-on
Sampleposition = 0
Waveloop(1) = 255
Looplength = 1
Limitreached = 0

Wavesample = Getadc(1)
Wavesample = Wavesample / 4
Waveloop(sampleposition) = Wavesample


'Main loop
Mainloop:
Do
   If Pind.7 = 1 Then Limitreached = 0
   Sampleposition = Sampleposition + 1
   Pwm0a = Waveloop(sampleposition)
   If Pind.7 = 0 And Limitreached = 0 Then
      If Pind.5 = 1 Then Goto Recordloop
      If Pind.5 = 0 Then Goto Punchloop
   End If
   If Sampleposition = Looplength Then Sampleposition = 0
   Loopspeed = Getadc(0) / 6
   Loopspeed = Loopspeed + 2                                                                        'sample speed pot value and do stuff with it
   Waitms Loopspeed
Loop


'Record new loop
Recordloop:
Sampleposition = 1
Do
   Wavesample = Getadc(1)
   Wavesample = Wavesample / 4
   Waveloop(sampleposition) = Wavesample
   Pwm0a = Waveloop(sampleposition)
   If Pind.7 = 1 Then
      Looplength = Sampleposition
      Sampleposition = 0
      Goto Mainloop
   End If
   If Sampleposition = 940 Then
      Limitreached = 1
      Looplength = Sampleposition
      Sampleposition = 0
      Goto Mainloop
   End If
   Sampleposition = Sampleposition + 1
   Loopspeed = Getadc(0) / 6
   Loopspeed = Loopspeed + 2
   Waitms Loopspeed
Loop


'Punch-in loop
Punchloop:
Do
   Wavesample = Getadc(1)
   Wavesample = Wavesample / 4
   Waveloop(sampleposition) = Wavesample
   Pwm0a = Waveloop(sampleposition)
   If Pind.7 = 1 Then
      Goto Mainloop
   End If
   If Sampleposition = Looplength Then
      Sampleposition = 0
   End If
   Sampleposition = Sampleposition + 1
   Loopspeed = Getadc(0) / 6
   Loopspeed = Loopspeed + 2
   Waitms Loopspeed
Loop


End